Subject: Re: [PATCH bpf-next 0/9] xdp: Support multiple programs on a single interface through chain calls

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Wed, 02 Oct 2019 21:25:28 +0200

Song Liu <[email-masked]> writes:

>> On Oct 2, 2019, at 11:38 AM, Song Liu <[email-masked]> wrote:
>> 
>> 
>> 
>>> On Oct 2, 2019, at 6:30 AM, Toke Høiland-Jørgensen <[email-masked]> wrote:
>>> 
>>> This series adds support for executing multiple XDP programs on a single
>>> interface in sequence, through the use of chain calls, as discussed at the Linux
>>> Plumbers Conference last month:
>>> 
>>> https://urldefense.proofpoint.com/v2/url?u=https-3A__linuxplumbersconf.org_event_4_contributions_460_&d=DwIDaQ&c=5VD0RTtNlTh3ycd41b3MUw&r=dR8692q0_uaizy0jkrBJQM5k2hfm4CiFxYT8KaysFrg&m=YXqqHTC51zXBviPBEk55y-fQjFQwcXWFlH0IoOqm2KU&s=NF4w3eSPmNhSpJr1-0FLqqlqfgEV8gsCQb9YqWQ9p-k&e= 
>>> 
>>> # HIGH-LEVEL IDEA
>>> 
>>> The basic idea is to express the chain call sequence through a special map type,
>>> which contains a mapping from a (program, return code) tuple to another program
>>> to run in next in the sequence. Userspace can populate this map to express
>>> arbitrary call sequences, and update the sequence by updating or replacing the
>>> map.
>>> 
>>> The actual execution of the program sequence is done in bpf_prog_run_xdp(),
>>> which will lookup the chain sequence map, and if found, will loop through calls
>>> to BPF_PROG_RUN, looking up the next XDP program in the sequence based on the
>>> previous program ID and return code.
>>> 
>>> An XDP chain call map can be installed on an interface by means of a new netlink
>>> attribute containing an fd pointing to a chain call map. This can be supplied
>>> along with the XDP prog fd, so that a chain map is always installed together
>>> with an XDP program.
>> 
>> Interesting work!
>> 
>> Quick question: can we achieve the same by adding a "retval to call_tail_next" 
>> map to each program? I think one issue is how to avoid loop like A->B->C->A, 
>> but this should be solvable? 
>
> Also, could you please share a real word example? I saw the example
> from LPC slides, but I am more curious about what does each program do
> in real use cases.

The only concrete program that I have that needs this is xdpcap:
https://github.com/cloudflare/xdpcap

Right now that needs to be integrated into the calling program to work;
I want to write a tool like it, but that can insert itself before or
after arbitrary XDP programs.

Lorenz, can you say more about your use case? :)

-Toke